# Benchmarks

These are custom ran benchmarks testing implementations timing on insertion, deletion, and data fetching.

## Stacks

```csharp
┌──────────────────┬────────────────────┬─────────────────────┐
│ Stack Operation  │ 100,000 items      │ 1,000,000 items     │
├──────────────────┼────────────────────┼─────────────────────┤
│ LinkedStack Push │ + 0s 15ms 701111ns │ + 0s 103ms 578697ns │
├──────────────────┼────────────────────┼─────────────────────┤
│ UArrayStack Push │ + 0s 33ms 674506ns │ + 0s 44ms 682102ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ BArrayStack Push │ + 0s 3ms 318560ns  │ + 0s 13ms 455307ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ LinkedStack Top  │ + 0s 2ms 589174ns  │ + 0s 16ms 513144ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ UArrayStack Top  │ + 0s 3ms 367356ns  │ + 0s 16ms 241029ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ BArrayStack Top  │ + 0s 3ms 168186ns  │ + 0s 14ms 461727ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ LinkedStack Pop  │ + 0s 5ms 66436ns   │ + 0s 28ms 798899ns  │
├──────────────────┼────────────────────┼─────────────────────┤
│ UArrayStack Pop  │ + 0s 3ms 528070ns  │ + 0s 3ms 528070ns   │
├──────────────────┼────────────────────┼─────────────────────┤
│ BArrayStack Pop  │ + 0s 2ms 697348ns  │ + 0s 2ms 697348ns   │
└──────────────────┴────────────────────┴─────────────────────┘
```

## Queues

```csharp
┌────────────────────────┬─────────────────────┬───────────────────────┐
│ Queue Operation        │ 100,000 items       │ 1,000,000 items       │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ LinkedQueue Enqueue    │ + 0s 30ms 912807ns  │ + 0s 152ms 813615ns   │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ UArrayQueue Enqueue    │ + 0s 5ms 971997ns   │ + 0s 44ms 899352ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFltArrayQueue Enqueue │ + 0s 3ms 824733ns   │ + 0s 18ms 102334ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFixArrayQueue Enqueue │ + 0s 8ms 141539ns   │ + 0s 17ms 4255ns      │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ LinkedQueue Peek       │ + 0s 2ms 939700ns   │ + 0s 14ms 605871ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ UArrayQueue Peek       │ + 0s 2ms 551683ns   │ + 0s 17ms 84358ns     │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFltArrayQueue Peek    │ + 0s 2ms 924676ns   │ + 0s 18ms 769628ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFixArrayQueue Peek    │ + 0s 2ms 275064ns   │ + 0s 19ms 66396ns     │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ LinkedQueue Dequeue    │ + 0s 4ms 498343ns   │ + 0s 17ms 900240ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ UArrayQueue Dequeue    │ + 1s 772ms 610030ns │ + 167s 551ms 767324ns │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFltArrayQueue Dequeue │ + 0s 3ms 678644ns   │ + 0s 19ms 273733ns    │
├────────────────────────┼─────────────────────┼───────────────────────┤
│ BFixArrayQueue Dequeue │ + 7s 16ms 659904ns  │ + 782s 431ms 330080ns │
└────────────────────────┴─────────────────────┴───────────────────────┘
```
